RDKit: DistGeom::BoundsMatrix Class Reference

| RDKit Open-source cheminformatics and machine learning.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
DistGeom::BoundsMatrix Class Reference

Class to store the distance bound. More...

`#include <BoundsMatrix.h>`

Inheritance diagram for DistGeom::BoundsMatrix:

## Public Types
typedef boost::shared_array< double > | DATA_SPTR
Public Types inherited from RDNumeric::Matrix< double >
typedef boost::shared_array< double > | DATA_SPTR

## Public Member Functions
| BoundsMatrix (unsigned int N)
| BoundsMatrix (unsigned int N, DATA_SPTR data)
double | getUpperBound (unsigned int i, unsigned int j) const
| Get the upper bound between points i and j. More...
void | setUpperBound (unsigned int i, unsigned int j, double val)
| Set the lower bound between points i and j. More...
void | setUpperBoundIfBetter (unsigned int i, unsigned int j, double val)
void | setLowerBound (unsigned int i, unsigned int j, double val)
| Set the lower bound between points i and j. More...
void | setLowerBoundIfBetter (unsigned int i, unsigned int j, double val)
double | getLowerBound (unsigned int i, unsigned int j) const
| Get the lower bound between points i and j. More...
bool | checkValid () const
Public Member Functions inherited from RDNumeric::SquareMatrix< double >
| SquareMatrix ()
| brief Square matrix of size N More...
| SquareMatrix (unsigned int N)
| SquareMatrix (unsigned int N, doubleval)
| SquareMatrix (unsigned int N, typename Matrix< double >::DATA_SPTR data)
virtual SquareMatrix< double > & | operator*= (doublescale)
| Multiplication by a scalar. More...
virtual SquareMatrix< double > & | operator*= (const SquareMatrix< double > &B)
| In place matrix multiplication. More...
virtual SquareMatrix< double > & | transposeInplace ()
| In place matrix transpose. More...
Public Member Functions inherited from RDNumeric::Matrix< double >
| Matrix (unsigned int nRows, unsigned int nCols)
| Initialize with a size. More...
| Matrix (unsigned int nRows, unsigned int nCols, doubleval)
| Initialize with a size and default value. More...
| Matrix (unsigned int nRows, unsigned int nCols, DATA_SPTR data)
| Initialize from a pointer. More...
| Matrix (const Matrix< double > &other)
| copy constructor More...
virtual | ~Matrix ()
unsigned int | numRows () const
| returns the number of rows More...
unsigned int | numCols () const
| returns the number of columns More...
unsigned int | getDataSize () const
virtual double | getVal (unsigned int i, unsigned int j) const
| returns a particular element of the matrix More...
virtual void | setVal (unsigned int i, unsigned int j, doubleval)
| sets a particular element of the matrix More...
virtual void | getRow (unsigned int i, Vector< double > &row) const
| returns a copy of a row of the matrix More...
virtual void | getCol (unsigned int i, Vector< double > &col) const
| returns a copy of a column of the matrix More...
double * | getData ()
| returns a pointer to our data array More...
const double * | getData () const
| returns a const pointer to our data array More...
Matrix< double > & | assign (const Matrix< double > &other)
| Copy operator. More...
virtual Matrix< double > & | operator+= (const Matrix< double > &other)
| Matrix addition. More...
virtual Matrix< double > & | operator-= (const Matrix< double > &other)
| Matrix subtraction. More...
virtual Matrix< double > & | operator/= (doublescale)
| division by a scalar More...
virtual Matrix< double > & | transpose (Matrix< double > &transpose) const
| copies the transpose of this Matrix into another, returns the result More...

## Additional Inherited Members
Protected Member Functions inherited from RDNumeric::Matrix< double >
| Matrix ()
Protected Attributes inherited from RDNumeric::Matrix< double >
unsigned int | d_nRows
unsigned int | d_nCols
unsigned int | d_dataSize
DATA_SPTR | d_data

## Detailed Description

Class to store the distance bound.

Basically a N by N matrix with lower distance bounds on the lower traingle and upper bounds in the upper triangle

Definition at line 26 of file BoundsMatrix.h.

## Member Typedef Documentation

typedef boost::shared_array<double> DistGeom::BoundsMatrix::DATA_SPTR

Definition at line 28 of file BoundsMatrix.h.

## Constructor & Destructor Documentation

DistGeom::BoundsMatrix::BoundsMatrix | ( | unsigned int | N | ) |
| inlineexplicit

Definition at line 30 of file BoundsMatrix.h.

DistGeom::BoundsMatrix::BoundsMatrix | ( | unsigned int | N,
|  | DATA_SPTR | data
| ) |  |
| inline

Definition at line 32 of file BoundsMatrix.h.

## Member Function Documentation

bool DistGeom::BoundsMatrix::checkValid | ( |  | ) | const
| inline

Do a simple check of the current bounds - i.e. all lower bounds are smaller than the existing upper bounds

Definition at line 103 of file BoundsMatrix.h.

References RDNumeric::Matrix< double >::d_nRows, getLowerBound(), and getUpperBound().

double DistGeom::BoundsMatrix::getLowerBound | ( | unsigned int | i,
|  | unsigned int | j
| ) |  | const
| inline

Get the lower bound between points i and j.

Definition at line 90 of file BoundsMatrix.h.

References RDNumeric::Matrix< double >::d_nCols, RDNumeric::Matrix< double >::d_nRows, RDNumeric::Matrix< double >::getVal(), and URANGE_CHECK.

Referenced by checkValid(), setLowerBoundIfBetter(), and setUpperBoundIfBetter().

double DistGeom::BoundsMatrix::getUpperBound | ( | unsigned int | i,
|  | unsigned int | j
| ) |  | const
| inline

Get the upper bound between points i and j.

Definition at line 36 of file BoundsMatrix.h.

References RDNumeric::Matrix< double >::d_nCols, RDNumeric::Matrix< double >::d_nRows, RDNumeric::Matrix< double >::getVal(), and URANGE_CHECK.

Referenced by checkValid(), setLowerBoundIfBetter(), and setUpperBoundIfBetter().

void DistGeom::BoundsMatrix::setLowerBound | ( | unsigned int | i,
|  | unsigned int | j,
|  | double | val
| ) |  |
| inline

Set the lower bound between points i and j.

Definition at line 69 of file BoundsMatrix.h.

References CHECK_INVARIANT, RDNumeric::Matrix< double >::d_nCols, RDNumeric::Matrix< double >::d_nRows, RDNumeric::Matrix< double >::setVal(), and URANGE_CHECK.

Referenced by setLowerBoundIfBetter().

void DistGeom::BoundsMatrix::setLowerBoundIfBetter | ( | unsigned int | i,
|  | unsigned int | j,
|  | double | val
| ) |  |
| inline

Set the lower bound between points i and j only if it is better than previously existing value (i.e. the new value is larger)

Definition at line 82 of file BoundsMatrix.h.

References getLowerBound(), getUpperBound(), and setLowerBound().

void DistGeom::BoundsMatrix::setUpperBound | ( | unsigned int | i,
|  | unsigned int | j,
|  | double | val
| ) |  |
| inline

Set the lower bound between points i and j.

Definition at line 48 of file BoundsMatrix.h.

References CHECK_INVARIANT, RDNumeric::Matrix< double >::d_nCols, RDNumeric::Matrix< double >::d_nRows, RDNumeric::Matrix< double >::setVal(), and URANGE_CHECK.

Referenced by setUpperBoundIfBetter().

void DistGeom::BoundsMatrix::setUpperBoundIfBetter | ( | unsigned int | i,
|  | unsigned int | j,
|  | double | val
| ) |  |
| inline

Set the upper bound between points i and j only if it is better than previously existing value (i.e. the new value is smaller)

Definition at line 61 of file BoundsMatrix.h.

References getLowerBound(), getUpperBound(), and setUpperBound().

The documentation for this class was generated from the following file:

- BoundsMatrix.h